-- This script is by Star and contains some code from Delf's boost mod as well.
-- I left a lot of comments to try and be helpful. If you use any of this, then you must credit us.

freeslot(
"MT_BSFX", "sfx_boost",
"MT_BSFX", "sfx_filter",
"MT_BSFX", "sfx_end",
"MT_BSFX", "sfx_charge",
"MT_BSFX", "sfx_chrge2",
"MT_BSFX", "sfx_chrge3",
"MT_BSFX", "sfx_gbmon",
"MT_BSFX", "sfx_gbmoff",
"MT_BSFX", "sfx_bmon",
"MT_BSFX", "sfx_bmoff",
"MT_BSFX", "sfx_xtreme",
"MT_BSFX", "sfx_stndrd"
)

-- This code is a way to cache audio for sound optimization, by pre-loading sound files whenever a map loads. 
-- This helps eliminate lag spikes from large sounds being played for the first time.
addHook("MapLoad", function(gamemap)
for player in players.iterate do
	local mobj = player.mo
	if not player.aura or not player.aura.valid then
		player.aura = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_BSFX)
		    S_StartSoundAtVolume(player.mo, sfx_boost, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_filter, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_charge, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_chrge2, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_chrge3, 0, player)
--			S_StartSoundAtVolume(player.mo, sfx_gbmon, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_gbmoff, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_bmon, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_bmoff, 0, player)
			S_StartSoundAtVolume(player.mo, sfx_xtreme, 0, player)
--			S_StartSoundAtVolume(player.mo, sfx_stndrd, 0, player)
			S_StopSoundByID(player.mo, sfx_boost)
			S_StopSoundByID(player.mo, sfx_filter)
			S_StopSoundByID(player.mo, sfx_end)
			S_StopSoundByID(player.mo, sfx_charge)
			S_StopSoundByID(player.mo, sfx_chrge2)
			S_StopSoundByID(player.mo, sfx_chrge3)
--			S_StopSoundByID(player.mo, sfx_gbmon)
			S_StopSoundByID(player.mo, sfx_gbmoff)
			S_StopSoundByID(player.mo, sfx_bmon)
			S_StopSoundByID(player.mo, sfx_bmoff)
			S_StopSoundByID(player.mo, sfx_xtreme)
--			S_StopSoundByID(player.mo, sfx_stndrd)
	end
end
end)

-- Just some stuff I need for audio and screenshake code.
local boosted = false

local client
local function screenshake(v, player)
client = player
    end
hud.add(screenshake)

-- MAIN
-- FUNCTION
addHook("PlayerThink", function(player)
if player.mo and player.mo.valid then
	if player.boosting then
		local mobj = player.mo
		if not player.aura or not player.aura.valid then
			player.aura = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_BSFX)
-- These sounds activate as we boost and will fully play, even if interrupted.
		    S_StartSound(player.mo, sfx_boost, player)
			S_StartSound(player.mo, sfx_chrge3, player)
-- Using this to separate "idle state after boosting" from "general idle state" to avoid an end boost sound file playing on level load from the audio caching.
-- See below note for where "boosted" comes into play.
			boosted = true
-- This is improved screenshake code with a small multiplayer radius, to prevent all players feeling the screenshake at all times.
-- Distance can be removed or increased. I kept it very subtle.
			if client and client.valid and client.mo
				local dist = P_AproxDistance(P_AproxDistance((client.mo.x - player.mo.x)/FRACUNIT, (client.mo.y - player.mo.y)/FRACUNIT), (client.mo.z - player.mo.z)/FRACUNIT)
				if dist >= 0 and dist < (player.powers[pw_super] and 512 or 256)*player.mo.scale/FRACUNIT
					P_StartQuake(40*FRACUNIT, 7)
				end
			end
		end
		player.aura.color = player.mo.color
		player.aura.angle = player.momangle2
		player.aura.target = player.mo
		player.aura.tracer = player.mo
		player.aura.scale = player.mo.scale
		player.aura.blendmode = AST_ADD
		if not (player.aura.flags2 & MF2_LINKDRAW) then
			player.aura.flags2 = $|MF2_LINKDRAW
		end
	elseif player.aura then
		if player.aura.valid then
-- Continued "boosted".
			if boosted then
				P_RemoveMobj(player.aura)
-- This sound plays when the boost ends, so that we don't hear an abrupt cut.
				S_StartSound(player.mo, sfx_end, player)
				S_StopSoundByID(player.mo, sfx_filter)
				boosted = false
			end
		end
		player.aura = nil
	end
-- This code is for looping the boosting sound, as we want it to play continuously until we stop.
		if player.boosting 
		and not S_SoundPlaying (player.mo, sfx_filter) then
			S_StartSound(player.mo, sfx_filter, player)
		end
-- This code is using player.charge from the boost script, in order to play chimes when we're closer to activating boost.
		if player.chargeboost then
			S_StartSound(player.mo, sfx_charge, player)
			player.chargeboost = false
		end
		if player.chargeboost2 then
			S_StartSound(player.mo, sfx_chrge2, player)
			player.chargeboost2 = false
		end
-- This is a hotfix to fix the boost sound from rarely continuing play after stopping.
		if not player.boosting then
			S_StopSoundByID(player.mo, sfx_filter)
		end
-- This is for our console command sound effects - the global command.
	if player.globalbooston then
		S_StartSound(player.mo, sfx_gbmon, player)
		player.globalbooston = false
	end
	if player.globalboostoff then
		S_StartSound(player.mo, sfx_gbmoff, player)
		player.globalboostoff = false
	end
-- This is for our console command sound effects - the extreme command.
	if player.boostextreme then
		S_StartSound(player.mo, sfx_xtreme, player)
		player.boostextreme = false
	end
	if player.booststandard then
		S_StartSound(player.mo, sfx_stndrd, player)
		player.booststandard = false
	end
	if player.booston then
		S_StartSound(player.mo, sfx_bmon, player)
		player.booston = false
	end
	if player.boostoff then
		S_StartSound(player.mo, sfx_bmoff, player)
		player.boostoff = false
	end
 end	
end)




