-- This script was originally created by AurumMighty for his Speed Effects mod and has been edited by Star.
-- If you use any of this, then you must credit him but I'd recommend getting the original version of his mod instead.

local speedwind = 1
local camzoom = 1

-- This is creating the effects as a function that we can then activate during boost mode.
local function Wind(mobj)
    local r = mobj.radius / FRACUNIT
    local explosion = P_SpawnMobj(
        mobj.x + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.y + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.z + (P_RandomKey(mobj.height / FRACUNIT) * FRACUNIT) - mobj.height/2,
        MT_THOK)
    explosion.sprite = SPR_RAIN
    explosion.renderflags = $|RF_PAPERSPRITE
    explosion.angle = R_PointToAngle2(0, 0, mobj.momx, mobj.momy)
    explosion.rollangle = R_PointToAngle2(0, 0, R_PointToDist2(0, 0, mobj.momx, mobj.momy), -mobj.momz) + ANGLE_90
    explosion.source = mobj
    explosion.blendmode = AST_ADD
end

addHook('ThinkFrame', do
	for player in players.iterate do
		if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor then
			local skin = skins[player.mo.skin]
			local grounded = P_IsObjectOnGround(player.mo)
			if player.mo.state ~= S_PLAY_DEAD and player.mo.state ~= S_PLAY_DRWN then
				-- Speed Wind --
-- This simply enables the effects while boosting.
					if player.boosting then
		        		Wind(player.mo)
		        	end
	        	-- Camera Zoom --
					if player.boosting then
						player.camerascale = skin.camerascale*5/4
					else
						player.camerascale = skin.camerascale
					end
			end
		end
	end
end)